This user manual is intended to document all of MISO's features and everything that a user could need to know about
using MISO. We will make every effort to keep it up to date. If you should come across any errors, outdated
information, or a feature that is missing from the user manual, please let us know by
[opening an issue](https://github.com/miso-lims/miso-lims/issues), so we can update it. Thanks!

## Introduction

[MISO](https://github.com/miso-lims/miso-lims) (**M**anaging **I**nformation for **S**equencing **O**perations) is a Lab
Information Management System (LIMS) developed at [Earlham Institute](http://www.earlham.ac.uk/) and the
[Ontario Institute for Cancer Research](https://oicr.on.ca/). MISO is heavily modelled upon the submission schemas
specified by the [European Nucleotide Archive (ENA)](https://www.ebi.ac.uk/ena) and is able to automatically generate
the required XML and data files for submission.

### History

MISO has been developed by the [Davey group](http://www.earlham.ac.uk/davey-group) at Earlham Institute since
February 2010. The first version of MISO was released internally to Earlham staff on 19th Sept 2011. The first beta
community release of MISO was 0.1.6, released May 31st, 2012.

In 2015, the [Genome Sequence Informatics](http://labs.oicr.on.ca/genome-sequence-informatics/) team at OICR chose MISO
as their new LIMS. OICR did not want to fork MISO entirely, so together the team at Earlham and OICR worked out a
development plan to better support multiple institutes with the same code base. All active work is visible on GitHub
and undergoes thorough code reviews and testing before being integrated into the mainline branches. Releases are pushed
biweekly to [GitHub](https://github.com/miso-lims/miso-lims/releases).

