-- Update migration checksums. This should only be done when altering a previous migration cannot be avoided

SET sql_notes = 0;
DROP PROCEDURE IF EXISTS updateMigrationChecksums;
SET sql_notes = 1;

DELIMITER //

CREATE PROCEDURE updateMigrationChecksums()
BEGIN
  IF EXISTS (SELECT 1 FROM information_schema.tables WHERE table_schema = (SELECT DATABASE()) AND table_name = 'flyway_schema_history') THEN
    -- V0800 was altered to remove use of a stored procedure that no longer exists
    UPDATE flyway_schema_history SET checksum = 1064873732 WHERE version = '0800' AND checksum = -1786810864;
  END IF;
END//

DELIMITER ;

CALL updateMigrationChecksums();
DROP PROCEDURE updateMigrationChecksums;
